blog/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView
from django.conf import settings
from django.conf.urls.static import static




urlpatterns = [
    path("admin/", admin.site.urls),
    path("posts/", include('post.urls')),
    path("accounts/", include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
    path('', RedirectView.as_view(url='/posts/', permanent=True)),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

post/urls.py
from django.urls import path
from . import views
urlpatterns = [
    path("", views.index, name='index'),
    path("posts/", views.PostlistView.as_view(), name='posts'),
    path('posts/<int:pk>', views.PostDetailView.as_view(),name='post-detail'),
    path('post/create/', views.PostCreate.as_view(), name='post-create'),
    path('post/<int:pk>/update/', views.PostUpdate.as_view(), name='post-update'),
    path('post/<int:pk>/delete/', views.PostDelete.as_view(), name='post-delete'),
    path('post/<int:pk>/comment/create', views.CommentCreate.as_view(), name='post-comment'),
    path('post/comment/reply/<int:pk>', views.ReplyCreate.as_view(), name='comment-reply'),
    path('post/comment/<int:pk>', views.CommentDetailView.as_view(), name='comment-detail'),
    


]

post/models.py
from django.db import models
from django.contrib.auth.models import User
# Create your models here.

from django.urls import reverse

class Post(models.Model):
    title = models.CharField(max_length=200,)
    body = models.TextField(max_length = None,)
    date = models.DateTimeField(auto_now_add=True)
    user = models.ForeignKey(User, on_delete=models.SET_NULL, null=True,)

    class Meta:
        ordering = ['title', 'user']

    def get_absolute_url(self):
        return reverse('post-detail', args=[str(self.id)])
    
    def __Str__(self):
        return self.title


class Comment(models.Model):
    """
    Model representing a comment against a blog post.
    """
    description = models.TextField(max_length=1000, help_text="Enter comment about blog here.")
    author = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
      # Foreign Key used because BlogComment can only have one author/User, but users can have multiple comments
    post_date = models.DateTimeField(auto_now_add=True)
    post= models.ForeignKey(Post, on_delete=models.CASCADE)
    
    class Meta:
        ordering = ["post_date"]

    def get_absolute_url(self):
        return reverse('comment-detail', args=[str(self.id)])

    def __str__(self):
        """
        String for representing the Model object.
        """
        len_title=75
        if len(self.description)>len_title:
            titlestring=self.description[:len_title] + '...'
        else:
            titlestring=self.description
        return titlestring


class Reply(models.Model):
    """
    Model representing a comment against a blog post.
    """
    description = models.TextField(max_length=1000, help_text="Enter comment reply!")
    author = models.ForeignKey(User, on_delete=models.SET_NULL, null=True)
      # Foreign Key used because BlogComment can only have one author/User, but users can have multiple comments
    post_date = models.DateTimeField(auto_now_add=True)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE)

    class Meta:
        ordering = ["post_date"]

    def __str__(self):
        """
        String for representing the Model object.
        """
        len_title=75
        if len(self.description)>len_title:
            titlestring=self.description[:len_title] + '...'
        else:
            titlestring=self.description
        return titlestring

post/views.py
from django.shortcuts import render
from .models import Post, Comment, Reply
from django.contrib.auth.models import User
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse
from django.shortcuts import get_object_or_404
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.urls import reverse_lazy
from django.contrib.auth.decorators import login_required

# Create your views here.

def index(request):
    num_posts = Post.objects.all().count()
    num_visits = request.session.get('num_visits', 1)
    num_users = User.objects.all().count()
    request.session['num_visits'] = num_visits+1
    context={'num_posts':num_posts , 'num_visits' : num_visits , 'num_users' : num_users ,}
    return render(request, 'index.html' , context )


class PostlistView(generic.ListView):
    model = Post
    paginate_by = 10
    ordering = ['-date']

class PostDetailView(generic.DetailView):
    model = Post


class PostCreate(LoginRequiredMixin,CreateView):
    model = Post
    fields = ['title', 'body',]
    def form_valid(self,form):
        form.instance.user = self.request.user
        return super().form_valid(form)


class PostUpdate(LoginRequiredMixin,UpdateView):
    model = Post
    fields = ['title', 'body',]


class PostDelete(LoginRequiredMixin,DeleteView):
    model = Post
    success_url = reverse_lazy('posts')



class CommentCreate(LoginRequiredMixin, CreateView):
    """
    Form for adding a blog comment. Requires login. 
    """
    model = Comment
    fields = ['description',]

    def get_context_data(self, **kwargs):
        """
        Add associated blog to form template so can display its title in HTML.
        """
        # Call the base implementation first to get a context
        context = super(CommentCreate, self).get_context_data(**kwargs)
        # Get the blog from id and add it to the context
        context['post'] = get_object_or_404(Post, pk = self.kwargs['pk'])
        return context
        
    def form_valid(self, form):
        """
        Add author and associated blog to form data before setting it as valid (so it is saved to model)
        """
        #Add logged-in user as author of comment
        form.instance.author = self.request.user
        #Associate comment with blog based on passed id
        form.instance.post=get_object_or_404(Post, pk = self.kwargs['pk'])
        # Call super-class form validation behaviour
        return super(CommentCreate, self).form_valid(form)

    def get_success_url(self): 
        """
        After posting comment return to associated blog.
        """
        return reverse('post-detail', kwargs={'pk': self.kwargs['pk'],})





class ReplyCreate(LoginRequiredMixin, CreateView):
    """
    Form for adding a blog comment. Requires login. 
    """
    model = Reply
    fields = ['description',]

    def get_context_data(self, **kwargs):
        """
        Add associated blog to form template so can display its title in HTML.
        """
        # Call the base implementation first to get a context
        context = super(ReplyCreate, self).get_context_data(**kwargs)
        # Get the blog from id and add it to the context
        context['comment'] = get_object_or_404(Comment, pk = self.kwargs['pk'])
        return context
        
    def form_valid(self, form):
        """
        Add author and associated blog to form data before setting it as valid (so it is saved to model)
        """
        #Add logged-in user as author of comment
        form.instance.author = self.request.user
        #Associate comment with blog based on passed id
        form.instance.comment=get_object_or_404(Comment, pk = self.kwargs['pk'])
        # Call super-class form validation behaviour
        return super(ReplyCreate, self).form_valid(form)

    def get_success_url(self): 
        """
        After posting comment return to associated blog.
        """
        return reverse('comment-detail', kwargs={'pk': self.kwargs['pk'],})




class CommentDetailView(LoginRequiredMixin,generic.DetailView):
    model = Comment

post/templates/post/comment_detail.html
{% extends 'base.html' %}

{% block content %}
    <div class="note note-success">
        <div class="fw-bold">{{comment.author}} | ({{comment.post_date}})</div>
        <p class="text-break">{{comment.description}}</p>
    </div>
<div class="d-flex justify-content-start">
<h4 class="my-2"><i class="fa-solid fa-comments"></i> Reply</h4>
<a href="#replybox" class="text-success"><i class="fa-solid fa-pen-to-square fa-lg m-1"></i></a>
</div>
<ul class="list-group list-group-light" style="height: 65vh; overflow-y: scroll;">
    {% for reply in comment.reply_set.all %}
    <li class="list-group-item d-flex justify-content-between align-items-start shadow-5 m-2">
      <div class="ms-2 me-auto">
        <div class="d-flex justify-content-between m-1">
          <div class="btn btn-secondary btn-sm mx-3"><i class="fas fa-user me-1"></i>{{reply.author}}</div>
          <div class="text-muted">({{reply.post_date}})</div>
        </div>
        <p class="text-break text-primary mx-3 my-2">{{reply.description}}</p>
      </div>
    </li>
    {% endfor %}
</ul>
<div class="mb-4 " id="replybox">
  {% if user.is_authenticated %}
  <a href="{% url 'comment-reply' comment.id %}" class="btn btn-success btn-sm">Add a new Reply</a>
  {% else %}
  <a href="{% url 'login'%}?next={{request.path}}"  class="btn btn-success btn-sm">Login to add a new reply</a>
  {% endif %}
  <a href="{% url 'post-detail' comment.post.id %}" class="btn btn-danger btn-sm"><i class="fa-solid fa-ban"></i></a>
  </div>
{% endblock %}

post/templates/post/comment_form.html
{% extends "base.html" %}

{% block content %}
<h1 class="display-6">Post your comment for: <a href="{% url 'post-detail' post.pk %}">{{post.title}}</a></h1>
<form action="" method="post">
    {% csrf_token %}
    <table class="table">
        <tr>
            {% comment %} <td class="col">{{ form.description.label_tag }}</td> {% endcomment %}
            <td class="col">{{ form.description }}</td>
        </tr>
    </table>
    <div class="col"><input type="submit" value="Submit" class="btn btn-success"/>
        <a href="{% url 'post-detail' post.pk %}" class="btn btn-danger"><i class="fa-solid fa-ban"></i></a></div>
</form>
{% endblock %}

post/templates/post/post_confirm_delete.html
{% extends "base.html" %}

{% block content %}

<h1 class="display-6">Delete post</h1>

<p class="note note-danger mx-4 my-4 text-break">Are you sure you want to delete the post: {{ post.title }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" action="" value="Yes, delete." class="btn btn-danger">
 <a href="{{ post.get_absolute_url }}" class="btn btn-success ">Cancel</a>
</form>

{% endblock %}

post/templates/post/post_detail.html
{% extends "base.html" %}

{% block content %}
<h1 class="display-6 text-break text-decoration-underline text-center">{{ post.title }}</h1>
<hr class="hr hr-blurry" />
<div>
  <button class="btn btn-secondary btn-sm"><i class="fa-solid fa-calendar-days"></i> {{post.date}}</button>
{% if user.is_authenticated %}
{% if user.id == post.user.id %}
<a href="{% url 'post-update' post.id %}" class="btn btn-secondary btn-sm "><i class="fa-solid fa-pen-to-square"></i></a>
<a href="{% url 'post-delete' post.id %}" class="btn btn-danger btn-sm "><i class="fa-solid fa-trash"></i></a>
{% endif %} 
{% endif %}
  <a href="https://api.whatsapp.com/send?text={{ request.build_absolute_uri }}" class="btn btn-dark btn-sm"><i
      class="fa-brands fa-whatsapp fa-lg"></i></a>
  <a href="https://facebook.com/share.php?u={{ request.build_absolute_uri }}" class="btn btn-dark btn-sm"><i
      class="fa-brands fa-facebook"></i></a>
  <a href="https://twitter.com/intent/tweet?url={{ request.build_absolute_uri }}" class="btn btn-dark btn-sm"><i
      class="fa-brands fa-twitter fa-lg"></i></a>
</div>
<div class="note mx-4 my-4 text-break note-success"> {{ post.body }}</div>
<div class="d-flex justify-content-start m-1">
<h4 class=""><i class="fa-solid fa-comments"></i> Comments</h4>
<a href="#commentbox" class="text-success"><i class="fa-solid fa-pen-to-square fa-lg m-1"></i></a>
</div>
<ul class="list-group list-group-light " style="height: 65vh; overflow-y: scroll;">
  {% for comment in post.comment_set.all %}
  <li class="list-group-item d-flex justify-content-between align-items-start shadow-5 m-2">
    <div class="ms-2 me-auto">
      <div class="d-flex justify-content-between m-1">
        <div class="btn btn-secondary btn-sm mx-3"><i class="fas fa-user me-1"></i> {{comment.author}}</div>
        <div class="text-muted">{{comment.post_date}}</div>
      </div>
      <p class="text-break text-primary mx-3 my-2">{{comment.description}}</p>
      <a href="{{ comment.get_absolute_url }}" class="btn btn-primary btn-sm ms-1">reply</a>
    </div>
  </li>
  {% endfor %}
</ul>
<div class="m-3" id="commentbox">
  {% if user.is_authenticated %}
  <a href="{% url 'post-comment' post.id %}" class="btn btn-success btn-sm ">Add a new comment</a>
  {% else %}
  <a href="{% url 'login'%}?next={{request.path}}" class="btn btn-success btn-sm ">Login to add a new comment</a>
  {% endif %}
  <a href="{% url 'posts' %}" class="btn btn-danger btn-sm"><i class="fa-solid fa-ban"></i></a>
</div>
{% endblock %}

post/templates/post/post_form.html
{% extends "base.html" %}

{% block content %}
<h3>Create Post</h3>
<form class=" form-group " action="" method="post">
    {% csrf_token %}
    <table class="table">
        <tr>
            <td class="col">{{ form.title.label_tag }}</td>
            <td class="col">{{ form.title }}</td>
        </tr>
        <tr>
            <td class="col">{{ form.body.label_tag }}</td>
            <td class="col">{{ form.body }}</td>
        </tr>
    </table>
    <div class="col"><input type="submit" class="btn btn-dark" value="Submit">
        <a href="{% url 'posts' %}" class="btn btn-danger"><i class="fa-solid fa-ban"></i></a>
    </div>

</form>
{% endblock %}

post/templates/post/post_list.html
{% extends "base.html" %}

{% block content %}
<h1 class="display-6">Post List</h1>

{% if post_list %}
<ul class="list-group list-group-light" style="height: 85vh; overflow-y: scroll;">
  {% for post in post_list %}
  <li class="list-group-item d-flex justify-content-between align-items-start shadow-5 m-2">
    <div class="ms-2 me-auto">
      <h5 class="fw-bold"><a href="{{ post.get_absolute_url }}" class="text-primary mx-2">{{ post.title }}</a></h5>
      <div class="m-2 fw-bold text-break">{{ post.body | slice:":100" }} ...</div>
      <div class="d-flex justify-content-start m-1">
        <div class="btn btn-secondary btn-sm mx-3"><i class="fas fa-user me-1"></i>{{ post.user.username }}</div>
        <div class="text-muted">{{ post.date }}</div>
      </div>
    </div>
  </li>
  {% endfor %}
</ul>
{% else %}
<div class="note note-success mb-3">
  <p>There are no posts in the library.</p>
</div>
{% endif %}
{% endblock %}

post/templates/post/reply_form.html
{% extends "base.html" %}

{% block content %}
<h1 class="display-6">Post your reply for:<br><a href="{% url 'comment-detail' comment.pk %}">{{comment.description}}</a></h1>
<form action="" method="post">
    {% csrf_token %}
    <table class="table">
        <tr>
            {% comment %} <td class="col">{{ form.description.label_tag }}</td> {% endcomment %}
            <td class="col">{{ form.description }}</td>
        </tr>
       
    </table>
    <div class="col"><input type="submit" value="Submit" class="btn btn-success"/>
        <a href="{% url 'comment-detail' comment.pk %}" class="btn btn-danger"><i class="fa-solid fa-ban"></i></a></div>
</form>
{% endblock %}